#include<bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int short
#define ll long long
#define ff first
#define ss second
#define pb push_back
#define m_p make_pair
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC target("avx,avx2")
using namespace std;
using namespace __gnu_pbds;
#define ordered set tree < int ,  null_type ,  less ,  rb_tree_tag ,  tree_order_statistics_node_update >
//mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
//constexpr int N=2147483647;
//constexpr int INF=2147483647;
//constexpr int BIGINF=1e18;
//constexpr int N=500001;
//constexpr int mod=998244353;
int A[100001];
int B[100001];
void rev(int l, int r)
{
    for(int i=0; i<=(r-l)/2; i++)
    {
        swap(A[l+i], A[r-i]);
    }
}
void solve()
{
    int n;
    cin>>n;
    for(int i=1; i<=n; i++)
    {
        cin>>A[i];
        B[i]=A[i];
    }
    sort(B+1, B+n+1);
    vector<pair<int, int> >ans;
    for(int i=1; i<=n; i++)
    {
        if(A[i]!=B[i])
        {
            int j=i;
            while(A[j]!=B[i])
                j++;
            rev(i, j);
            ans.pb({i, j});
//            for(int k=1; k<=n; k++)
//            {
//                cout<<A[k]<<" ";
//            }
//            cout<<'\n';
        }
    }
    cout<<ans.size()<<'\n';
    for(auto [i,j]:ans)
        cout<<i<<" "<<j<<'\n';

}
main()
{
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t=1;
//    cin>>t;
    while(t)
    {
        t--;
        solve();
    }
}
//5 8
//1 2
//1 3
//1 5
//2 3
//3 4
//4 1
//5 3
//5 2

